LipAngle = 20;
OuterMouthpieceDiameter = 25;
MouthpieceLength = 55;
MouthCurveRadius = 40;
WallThickness = 4;
OpeningWidth = 6;
InsertDepth = 25;
WindowAngle = 75;
WindowLength =10; //22
WindowWidth =15;
DistanceFromInnerEdge = 0;
LipThickness = 2;
OD1 = 21.5;
OD1_Length = 14;//18.24;
OD1_Start = 5;
OD2 = 17.5;
OD2_Length = 12;
OD3 = 11;
OD3_Length = 12;
ExitID = 8;

//Outer circle
difference(){
cylinder(MouthpieceLength, OuterMouthpieceDiameter/2, OuterMouthpieceDiameter/2);
translate([0,0,-1])
cylinder(MouthpieceLength+4, OuterMouthpieceDiameter/2-WallThickness, OuterMouthpieceDiameter/2-WallThickness);
translate([-100,-MouthCurveRadius,MouthpieceLength])
rotate([0,90,0])
cylinder(200, MouthCurveRadius,MouthCurveRadius);
translate([-WindowWidth/2, 0, MouthpieceLength-InsertDepth-DistanceFromInnerEdge-WindowLength])
cube([WindowWidth, OuterMouthpieceDiameter/2, WindowLength]);   
} 

//Insert
difference(){
translate([0,0,MouthpieceLength-InsertDepth])
cylinder(InsertDepth, OuterMouthpieceDiameter/2-WallThickness, OuterMouthpieceDiameter/2-WallThickness);
translate([-100,-MouthCurveRadius,MouthpieceLength])
rotate([0,90,0])
cylinder(200, MouthCurveRadius,MouthCurveRadius);
//Fippple Opening
 translate([-OuterMouthpieceDiameter/2, OuterMouthpieceDiameter/2 - OpeningWidth, -2])
    cube([OuterMouthpieceDiameter, OuterMouthpieceDiameter,MouthpieceLength +4]);  
}

//Opening 
translate([-WindowWidth/2, OuterMouthpieceDiameter/2 - OpeningWidth,MouthpieceLength - InsertDepth-DistanceFromInnerEdge-WindowLength/2])
difference(){
translate([-1,0,-WindowLength/2])
    cube([WindowWidth+2, LipThickness, WindowLength/2]);
    color("blue") 
    rotate([LipAngle,0,0])
    translate([-2,0,-WindowLength/2]) 
    cube([WindowWidth+4, LipThickness, WindowLength]);
   } 


   
///Lower half of mouthpiece and Outer diameters
difference(){
union(){    

 //Between Mouthpiece and Outer Diameters
translate([0,0,-(OD1_Start)]) 
cylinder(OD1_Start, OD1/2,OuterMouthpieceDiameter/2, center = false);

//Outer Diameter 1
$fn = 200;
translate([0,0,-(OD1_Start+OD1_Length)])
CylinderOneRoundedEdge(OD1/2,OD1/2,OD1_Length,2);

// Outer Diameter 2
$fn = 200;
translate([0,0,-(OD1_Start+OD1_Length+OD1_Length)])
CylinderOneRoundedEdge(OD2/2,OD2/2,OD2_Length,2);

// Outer Diameter 3
$fn = 200;
translate([0,0,-(OD1_Start+OD1_Length+OD1_Length+OD2_Length)])
CylinderOneRoundedEdge(OD3/2,OD3/2,OD3_Length,2); 


}

// Bore - subtract the inner bore
z = OD1_Start+OD1_Length+OD1_Length+OD2_Length+4;
translate([0,0,-(z-1)])
cylinder((z),ExitID/2,OuterMouthpieceDiameter/2 - WallThickness);
}


module CylinderOneRoundedEdge(r1=10,r2=10,h=10,b=.5){
    
 hull(){
        translate([0,0,-b])    
        rotate_extrude() 
        translate([r1-b,b,0]) 
        circle(r = b); 
       cylinder (h,r2, r2);
}    

   }
   
